{***********************************************************************}
{ 	        Pruebas de captura de mensajes del portapapeles             }
{                                                                       }
{     	        Copyright (C) 2003 por Neftal - Germn Estvez         }
{               E-mail: Neftali_GER@hotmail.com                         }
{***********************************************************************}
{ Este ejemplo puede ser distribuido libremente.                        }
{ ----------------------------------------------------------------------}
{ Version 1.01. Date last modified:  20/08/2003                         }
{ ----------------------------------------------------------------------}
unit FVis;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TFormVisualizador = class(TForm)
    PanelAbout: TPanel;
    PanelControles: TPanel;
    spAbout: TSpeedButton;
    Memo1: TMemo;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure PanelAboutClick(Sender: TObject);
  private
    { Private declarations }
    procedure WMDrawClipboard(var Message : TMessage); message WM_DRAWCLIPBOARD;
    procedure WMChangeCBChain(var Message : TWMChangeCBChain); message WM_CHANGECBCHAIN;
  public
    { Public declarations }
  end;

var
  FormVisualizador: TFormVisualizador;
  NextViewer:THandle;

implementation

{$R *.dfm}

uses
  Clipbrd,
  {Foms} FAbout;

{ TForm1 }

procedure TFormVisualizador.WMChangeCBChain(var Message: TWMChangeCBChain);
begin

  // Se ha eliminado el siguiente en la cadena a nosotros ?
  if (Message.Remove = NextViewer) then begin
    // Actualizamos nuestro apuntador al siguiente
    NextViewer := Message.Next;
  end
    // el eliminado no es el siguiente a nosotros ==> propagamos el mensaje
  else begin
    if (NextViewer <> 0) then begin
      // Parametros:
      // +  A quien le enviamos el mensaje
      // +  el mensaje
      // +  los dos parmetros en el orden correcto
      SendMessage(NextViewer ,WM_CHANGECBCHAIN, TMessage(Message).WParam,
        TMessage(Message).LParam);
    end;
  end;

  
end;

procedure TFormVisualizador.WMDrawClipboard(var Message: TMessage);
begin

  // Hacemos visible el control apropiado segun el tipo del dato.
  Memo1.Visible := Clipboard.HasFormat(CF_TEXT);
  Image1.Visible := Clipboard.HasFormat(CF_BITMAP);

  // Format textO
  if Clipboard.HasFormat(CF_TEXT) then begin
    Memo1.Text := Clipboard.AsText ;
  end;

  // Bitmap
  if Clipboard.HasFormat(CF_BITMAP) then begin
    Image1.Picture.LoadFromClipboardFormat(CF_BITMAP,ClipBoard.GetAsHandle(CF_BITMAP),0);
  end;


  //...  Podemos programar el resto de formatos


  // Existe otro visualizador encadenado ?
  if (NextViewer <> 0) then  begin
    // Le envo el mensage que he recibido
    SendMessage(NextViewer,Message.Msg, Message.WParam,Message.LParam);
  end;

end;

procedure TFormVisualizador.FormCreate(Sender: TObject);
begin
  // Registrar el Clipbpard viewer
  NextViewer := SetClipboardViewer(Handle);
  // Inicializar controles de visiualizacion
  Memo1.Align := alClient;
  Memo1.Visible := False;
  Image1.Align := alClient;
  Image1.Visible := False;
end;

procedure TFormVisualizador.PanelAboutClick(Sender: TObject);
var
  FormAbout: TFormAbout;
begin
  Application.CreateForm(TFormAbout, FormAbout);
  FormAbout.ShowModal;
end;

end.

